﻿using System;
using System.Collections.Generic;
using System.Text;

namespace opentkprojekt.Helpers
{
    public class Convertor
    {
        public static double StringToDouble(string s, double defaultValue = 0.0)
        {
            double output = defaultValue;
            if (Double.TryParse(s, out output))
            {
                return output;
            }
            if (Double.TryParse(s.Replace(".", ","), out output))
            {
                return output;
            }
            if (Double.TryParse(s.Replace(",", "."), out output))
            {
                return output;
            }
            return defaultValue;
        }

        public static double DegToRad(double deg)
        {
            return deg / 180.0 * Math.PI;
        }

        public static double RadToDeg(double rad)
        {
            return rad / Math.PI * 180.0;
        }
    }
}
