﻿using System;
using System.Collections.Generic;
using System.Text;
using OpenTK.Graphics;
using OpenTK;

namespace opentkprojekt
{
    class SphericalLinearInterpolation
    {
        public static Quaterniond Interpolate(Quaterniond q1, Quaterniond q2, double time)
        {
            Quaterniond nq1 = q1.Normalized();
            Quaterniond nq2 = q2.Normalized();
            double angle = Math.Acos(nq1.X * nq2.X + nq1.Y * nq2.Y + nq1.Z * nq2.Z + nq1.W * nq2.W);
            if (Double.IsNaN(angle))
            {
                angle = 0.0f; // Sometimes there is strange bug in computation, when both quaternions are equal, angle between them is NaN (which is wrong), so i set it to zero.
            }
            if (Math.Abs(angle) <= Math.PI * 5f / 180.0f)
            {
                return ((1.0f - time) * nq1 + time * nq2).Normalized();
            }
            return Math.Sin((1.0f - time) * angle) / Math.Sin(angle) * nq1 + Math.Sin(time * angle) / Math.Sin(angle) * nq2;
        }
    }
}
